package at.ac.uibk.gitsearch.repository.vocabulary;

import at.ac.uibk.gitsearch.domain.vocabulary.VocabularyItem;
import java.net.URI;
import java.util.List;
import java.util.Map;
import org.springframework.stereotype.Repository;

@Repository
public interface VocabularyRepository {
    /**
     * reads the map of urls
     *
     * @return
     */
    Map<String, URI> getVocabularyURLMap();

    /**
     * reads the content of the subject URL
     *
     * @param subject
     *            the subject
     * @param type
     *            the expected return type
     * @return
     */
    <T extends VocabularyItem> T[] getVocabularyItemsFor(String subject, Class<?> type);
    /**
     * reads the content of the subject URL
     *
     * @param subject
     * @return
     */
    VocabularyItem[] getVocabularyItemsFor(String subject);

    /**
     * returns the currently supported languages.
     *
     * @return
     */
    List<String> getSupportedLanguageCodes();
}
