import { ProjectDTO } from './project-dto.model';
import { MetadataFileDTO } from './metadata-file-dto.model';
import { UserProvidedMetadataDTO } from './user-provided-metadata-dto.model';

export interface SearchStatisticsDTO {
  views?: number;
  downloads?: number;
  badgeRewarded?: boolean;
}

export interface SearchResultDTO {
  exerciseId: string;
  project: ProjectDTO;
  file: MetadataFileDTO;
  metadata: UserProvidedMetadataDTO;
  ranking5: number;
  supportedActions: PluginActionInfo[];
  searchStatistics?: SearchStatisticsDTO;
}

export interface SearchResultDTO {
  exerciseId: string;
  project: ProjectDTO;
  file: MetadataFileDTO;
  metadata: UserProvidedMetadataDTO;
  ranking5: number;
  supportedActions: PluginActionInfo[];
  searchStatistics?: SearchStatisticsDTO;
}

export interface ChildInfo {
  childId: string;
  title: string;
}

export interface ExtendedSearchResultDTO extends SearchResultDTO {
  // thesis

  numberOfWatchlistEntries: number;
  numberOfLikes: number;
  userHasLiked: boolean;
  childInfos: ChildInfo[] | undefined;
}

export function hasChildren(exercise?: SearchResultDTO): boolean {
  return (
    exercise !== undefined &&
    exercise !== null &&
    exercise.file !== undefined &&
    exercise.file !== null &&
    exercise.file.children !== undefined &&
    exercise.file.children !== null &&
    exercise.file.children.length > 0
  );
}

export function getPathOfExerciseId(exerciseId: string): string {
  if (exerciseId) {
    const colonPos = exerciseId.indexOf(':"');
    if (colonPos >= 0) return exerciseId.slice(colonPos + 1);
  }
  return '';
}

export interface PluginActionInfo {
  plugin: string;
  action: string;
  commandName: string;
}

export function equalPluginActionInfo(a: PluginActionInfo, b: PluginActionInfo): boolean {
  return a.action === b.action && a.commandName === b.commandName && a.plugin === b.plugin;
}
