package at.ac.uibk.gitsearch.service.mapper;

import static org.assertj.core.api.Assertions.assertThat;
import static org.junit.Assert.assertEquals;

import at.ac.uibk.gitsearch.domain.User;
import at.ac.uibk.gitsearch.domain.UserWatchList;
import at.ac.uibk.gitsearch.domain.WatchListEntry;
import at.ac.uibk.gitsearch.service.dto.WatchListEntryDTO;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

public class WatchListEntryMapperTest {

    private WatchListEntryMapper watchListEntryMapper;

    @BeforeEach
    public void setUp() {
        watchListEntryMapper = new WatchListEntryMapperImpl();
    }

    @Test
    public void testEntityFromId() {
        Long id = 1L;
        assertThat(watchListEntryMapper.fromId(id).getId()).isEqualTo(id);
        assertThat(watchListEntryMapper.fromId(null)).isNull();
    }

    @Test
    public void testWatchlistIdMapping() {
        final long wlId = 25L;
        final long wleId = 13L;
        UserWatchList wl = new UserWatchList();
        wl.setId(wlId);
        wl.setName("Just testing");
        wl.setUser(new User());

        WatchListEntry wle = new WatchListEntry();

        wle.setId(wleId);
        wle.setExerciseId("unusedExerciseId");
        wle.setExerciseName("Test Exercise Name");
        wle.setWatchlist(wl);

        final WatchListEntryDTO wlAsDTO = watchListEntryMapper.toDto(wle);
        assertEquals(wlAsDTO.getId(), wle.getId());
        assertEquals(wlAsDTO.getExerciseId(), wle.getExerciseId());
        assertEquals(wlAsDTO.getExerciseName(), wle.getExerciseName());
        assertEquals(wlAsDTO.getWatchlistId(), wle.getWatchlist().getId());
    }
}
